//import de librerias
#include <Servo.h>

//Declaracion de servos
Servo base;
#define PIN_base 9  //Pin para el servo de la base 9
#define POT A0
#define ENC_COUNT_REV 600

int poservo=0;


//Posicion inicial para servos
int a0_init = 0;
int previousMillis = 0;
int currentMillis = 0;
int motorPwm = 0;
int rpm = 0;

void updateEncoder(); 
void updatePOS(); 
void encoderPinChangeA();
void encoderPinChangeB();
void recargar();
float computePID(float input, float setPoint);

void updateEncoder();
//Declaracion de posiciones (metros)
const float Pos_x = 0.01; //posicion eje x del vaso
const float Pos_y = 1.17; //posicion eje y del vaso
float Ang_disparo = 80; //posicion con el que se quiere disparar

float dist = 0; //distancia a la cual quedara el vaso (calculada)
float Ang_base = 0;  //Angulo para girar la base (calculada)
float vel = 0; //Velocidad a la cual debe viajar la bolita
float grav = 9.8; //consante gravedad
float H_lanz = 0.263; //Altura vertical del lanzamiento
float H_vaso = 0.12; //Altura Vertical del vaso
float L_brazo = 0.2; //Largo del brazo catapulta
float d2 = 0.12; //diametro de la 2da polea
float d1 = 0.012; //diametro 1era polea
float n1 = 0; //Variable a la que deberia estar girando el motor

//Variables para el PID
double kp = 0.00001; //Control proporcional
//double ki=5; //Control integral, hasta el momento no se ocupara
double kd = 0; //Control derivativo

unsigned long currentTime, previousTime;
double elapsedTime;
double error;
double lastError;
int input, output;
double setPoint;
double cumError, rateError;
float pweta;

int interval = 500;

// Pines para el Puente H
int IN1 = 4; //IN1 del Punte H que conecta al motor DC para el lanzamiento
int IN2 = 6; //IN2 del Punte H que conecta al motor DC para el lanzamiento
int ENA = 5; //Enable A Permite el movimiento del motor DC

#define ENC_A 2 // Connecion al encoder A
#define ENC_B 3 // Connecion al encoder B


//Variables para el contador del Encoder
volatile long encoderValue = 0;
volatile long posicion = 0;
int direction = 1;
float Vel_enc = 0;
int enc_count = 0;
volatile long cuenta = 0;

//void count() {
  //int b = digitalRead(ENC_B);
  //if (b == HIGH) {
    //enc_count--;
  //}
  //else if (b == LOW) {
    //enc_count++;
  //}
//}

//Empieza el calculo
void setup() {
  base.attach(9);  

  //Primera parte representa al calculo de la posicion para el servo base
  //Arranque del serial
  Serial.begin(115200);

  // posicionamiento angulo 0
  base.write(0);
  delay (5000);

  // Calculo del angulo de la base
  if (Pos_x > 0) {
    Ang_base = atan(Pos_y / Pos_x) * 4068 / 71;
  } else if (Pos_x < 0) {
    Ang_base = 180 - (atan(Pos_y / (-1 * Pos_x)) * 4068 / 71);
  } else if (Pos_x == 0) {
    Ang_base = 90;
  }
  Serial.print("Angulo de la base: ");
  Serial.print(Ang_base);
  //Serial.print('\n');
  base.write(Ang_base);
  delay(3000);


  // Attach interrupt 
  attachInterrupt(digitalPinToInterrupt(ENC_B), updateEncoder, RISING);
  attachInterrupt(digitalPinToInterrupt(ENC_B), updatePOS, RISING);

  // Setup initial values for timer
  previousMillis = millis();


  //Calculo de las RPM necesarias en el motor DC
  dist = sqrt(Pos_x * Pos_x + Pos_y * Pos_y);
  vel = sqrt(4.9*dist*dist / ( cos(Ang_disparo * 71 / 4068)*cos(Ang_disparo * 71 / 4068)*(H_lanz + dist * tan(Ang_disparo * 71 / 4068) - H_vaso)));
  Serial.print("Velocidad necesaria: ");
  Serial.print(vel);
  //Serial.print('\n');
 
  //RPM necesaria en el motor
  n1 = d2 * vel / (d1 * L_brazo);
  Serial.print("Distancia: ");
  Serial.print(dist);
  Serial.print('\n');
  //Serial.print("RPM necesarias por el motor: ");
  //Serial.print(n1);
  //setPoint = n1+1700;
  //Serial.print(setPoint);


  //Programacion Encoder para lectura de las RPM
  pinMode(ENC_A, INPUT_PULLUP); //Se le establece la prioridad
  pinMode(ENC_B, INPUT_PULLUP); //Se le establece la prioridad
  attachInterrupt(0, encoderPinChangeA, CHANGE); //El A del encoder se contara cada vez que cambia
  attachInterrupt(1, encoderPinChangeB, CHANGE); // El B del encoder se contara cada vez que cambia
  attachInterrupt(0, updatePOS, CHANGE);
  attachInterrupt(1, updatePOS, CHANGE);


  //Definir Para el Puente H los OUTPUT
  pinMode(IN1, OUTPUT);
  pinMode(IN2, OUTPUT);
  pinMode(ENA, OUTPUT);

  previousMillis = millis();

  //Distancia a PWM
  //pweta= (dist*100+ 325.63)/1.7437;
  pweta=map(dist, 0.3, 1.17, 0, 255);
  Serial.print("Pulso: ");
  Serial.print(pweta);
  //Serial.print('\n');
  

  //Prender motor sentido horario de 1 en 1 en el rango completo de 0 a 255
  //analogWrite(ENA,pweta); //Valor desde 0 a 255
  digitalWrite(IN1, LOW);
  digitalWrite(IN2, HIGH);
  //delay(500);

}
// Dentro del loop tendremos El contador de velocidad RPM


void loop() {
  // put your main code here, to run repeatedly:

  //Prender motor sentido horario de 1 en 1 en el rango completo de 0 a 255
  Serial.print('\n');
  //analogWrite(ENA,pweta); //Valor desde 0 a 255
  //Serial.print("volvi");
  digitalWrite(IN1, LOW);
  digitalWrite(IN2, HIGH);
  Serial.print(pweta);
  analogWrite(ENA,pweta); //Valor desde 0 a 255
  //delay(1000);
  
  // Calculate RPM
  rpm = (float)(encoderValue * 60 / ENC_COUNT_REV);
  if (rpm== 0 && posicion > 2400){
    Serial.print("posicion " );
    Serial.print(posicion);
    Serial.print('\n');
  }
  /*Serial.print("PWM VALUE: ");
  Serial.print(motorPwm);
  Serial.print('\t');
  Serial.print(" SPEED: ");
  Serial.print(rpm);
  Serial.print('\n');
  */
  if (posicion > 2700){
    Serial.print("posicion max alcanzada, recargar ");
    //Serial.print('\n');
    
    recargar();
    
  }

  // Control motor with potentiometer
    //motorPwm = map(analogRead(POT), 0, 1023, 0, 255);
    //motorPwm = map(0, 0, 1023, 0, 255);
    //digitalWrite(IN1, LOW);
    //digitalWrite(IN2, HIGH);
    //analogWrite(ENA,motorPwm);
    

   // Update RPM value every second
  currentMillis = millis();
  if (currentMillis - previousMillis > interval) {
    previousMillis = currentMillis;
    
    
    //Only update display when there is a reading
    
    if (motorPwm > 0 || rpm > 0) {
      Serial.print("PWM VALUE: ");
      Serial.print(motorPwm);
      Serial.print('\t');
      Serial.print(" PULSES: ");
      Serial.print(encoderValue);
      Serial.print('\t');
      Serial.print(" SPEED: ");
      Serial.print(rpm);
      Serial.println(" RPM");
    }
     
    
  
  

  //Empieza el PID
   //input = rpm;
   //output = int(computePID(input,setPoint));
   //motorPwm = map(output, -1100, 1100, 0, 255);
   //analogWrite(ENA,motorPwm);
   
   //analogWrite(ENA, output);
   

   encoderValue = 0;
}
}

//Calculo PID
float computePID(float input, float setPoint) {
  //currentTime = millis();
  //elapsedTime = (double)(currentTime - previousTime);
  error = setPoint - input;
  //rateError = (error - lastError) / elapsedTime;
  double out = kp * error;// + kd * rateError; //+ki*cumError
  Serial.print(" error = ");
  Serial.print(error);
  Serial.print('\n');
  /*
  Serial.print(" setPoint ");
  Serial.print(setPoint);
  Serial.print('\n');
  Serial.print(" error = ");
  Serial.print(error);
  Serial.print('\n');
  Serial.print(" input = ");
  Serial.print(input);
  Serial.print('\n');
  Serial.print("Respuesta ");
  Serial.print(out);
  Serial.print('\n');*/
  //lastError = error;
  //previousTime = currentTime;
  return out;
}

//Codigo para conocer la dirección de giro
void encoderPinChangeA() {
  encoderValue += 1;
  direction = digitalRead(ENC_A) == digitalRead(ENC_B) ? 1 : -1;
}

void updateEncoder(){
  // Increment value for each pulse from encoder
  encoderValue++;
}

void updatePOS(){
  // Increment value for each pulse from encoder
  posicion++;
}

void recargar(){
  analogWrite(ENA,LOW);
  digitalWrite(IN1, LOW);
  digitalWrite(IN2, LOW);
  delay(2000);
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2, LOW);
  analogWrite(ENA,180);
  delay(700);

  
  //while (posicion > 100){
    //digitalWrite(IN1, HIGH);
    //digitalWrite(IN2, LOW);
    //analogWrite(ENA,250);
    //posicion = posicion -600;
  //}
  analogWrite(ENA,LOW);
  digitalWrite(IN1, LOW);
  digitalWrite(IN2, LOW);
  Serial.print("volve a comenzar lanzamiento");
  //Serial.print('\n');
  delay(5000);
  
  //Serial.print(posicion);
  posicion = 0;
}

void encoderPinChangeB() {
  //encoderValue+= 1;
  direction = digitalRead(ENC_A) != digitalRead(ENC_B) ? 1 : -1;
}
